package com.yuandian.dataflow.proto.decode;

 
import java.io.BufferedReader;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 
 * @author User
 *
 */
public class ApmBaseDataFlow extends PacketBase {
	private static Logger logger = LoggerFactory.getLogger(ApmBaseDataFlow.class);
	public static int SIZE = 156;//88;//
	/**
	 * 抓包口
	 */
	public long probeIf;

	
	//四元组
	/**
	 * 请求端口
	 */
	public int requestPort;
	/**
	 * 响应端口
	 */
	public int responsePort;
	/**
	 * 请求IP
	 */
	public long requestIp;
	/**
	 * 响应Ip
	 */
	public long responseIp;

	/**
	 * 源mac
	 */
	public long srcMac;

	/**
	 * 目的mac
	 */
	public long dstMac;

	/**
	 * 链路编号
	 */
	public long vlanId;
	
	public long tvSec;
	public long tvUsec;
	
	/**
	 * 开始时间
	 */
	public long startTm;

	/**
	 * 总字节数
	 */
	public long totalBytes;

	/**
	 * 总包数
	 */
	public long totalPackets;
	/**
	 * 总丢包数
	 */
	public long totalDropPackets;
	/**
	 * 重传延时
	 */
	public long retranTimeDelay;
	/**
	 * 客户端rtt
	 */
	public long clientRtt;
	
	/**
	 * 服务端Rtt
	 */
	public long serverRtt;
	
	
	/**
	 * 用户响应时间
	 */
	public long userResponseTime;
	/**
	 * 服务响应时间
	 */
	public long serverResponseTime;
	/**
	 * tcp回话连接失败数
	 */
	public long conFail;

	/**
	 * 会话重置数
	 */
//	public long reset;
	
	/**
	 * 服务端总字节数
	 */
	public long bytesIn;
	/**
	 * 客户端总字节数
	 */
	public long bytesOut;
	/**
	 * 探针推送时间
	 */
	public long timeFlag;
	
	/**
	 * 结束时间
	 */
	public long endTm;
	
	/**
	 * 结束时间微秒
	 */
	public long endTmUsec;
	
	/**
	 * 总响应数
	 */
	public long	responNum;
	/**
	 * 客户端零窗口数
	 */
	public long	csWindow;
	/**
	 * 服务端零窗口数
	 */
	public long	scWindow;
	/**
	 * 客户端重置数
	 */
	public long	csReset;
	/**
	 * 服务端重置数
	 */
	public long	scReset;
	/**
	 * 客户端重传数
	 */
	public long	csRetran;
	/**
	 * 服务端重传数
	 */
	public long	scRetran;
	/**
	 * 会话建立时间
	 */
	public long	connSetupTm;
	/**
	 * 新建会话数
	 */
	public long	newSession;
	
	public long csAlert;
	
	public long scAlert;

	public String protocal;
	
	
	
	@Override
	public PacketBase  Parse(PacketHeader header,ByteBuffer data) throws Exception {
		ApmBaseDataFlow oneData = new ApmBaseDataFlow();
				
		oneData.setPacketHeader(header);
		
		oneData.probeIf = data.getLong(4);
		
		
		oneData.requestPort = data.getInt( 2);
		
		oneData.responsePort = data.getInt( 2);
		
		oneData.requestIp = data.getLong(4);
		
		oneData.responseIp = data.getLong(4);
		
		
		oneData.srcMac = data.getLong(6);
		
		oneData.dstMac = data.getLong(6);
		
		oneData.vlanId = data.getLong(4);
		

		oneData.tvSec = data.getLong(4);
		
		oneData.tvUsec = data.getLong(4);
		
		
//		oneData.startTm = data.getLong(8);

		
		oneData.totalBytes = data.getLong(4);
		
		oneData.totalPackets = data.getLong(4);
		
		oneData.totalDropPackets = data.getLong(4);
		
		oneData.retranTimeDelay = data.getLong(4);
		
		oneData.clientRtt = data.getLong(4);
		
		//服务端Rtt
		oneData.serverRtt = data.getLong(4);
		
		oneData.userResponseTime = data.getLong(4);
		
		oneData.serverResponseTime = data.getLong(4);
		
		oneData.conFail = data.getLong(4);
		
		
//		oneData.reset = data.getLong(4);

		oneData.bytesIn = data.getLong(4);
		
		oneData.bytesOut = data.getLong(4);
		
		oneData.timeFlag = data.getLong(4);
		
		
		oneData.endTm = data.getLong(4);
	
		oneData.endTmUsec = data.getLong(4);
	
		
		oneData.responNum = data.getLong(4);
		
		oneData.csWindow  = data.getLong(4);
		
		oneData.scWindow  = data.getLong(4);
		
		oneData.csReset   = data.getLong(4);
		
		oneData.scReset   = data.getLong(4);
		
		oneData.csRetran  = data.getLong(4);
		
		oneData.scRetran  = data.getLong(4);
		
		oneData.connSetupTm = data.getLong(4);
		
		oneData.newSession = data.getLong(4);
		
		oneData.csAlert = data.getLong(4);
		
		oneData.scAlert = data.getLong(4);

		oneData.protocal = data.slice().toString() ;
		
		return oneData;
	}

	@Override
	public String[] getData() {
		return null; 
	}

	@Override
	public int getInterfaceNumber() {
		return 0;
	}

	@Override
	public int getUnitPacketLength() {
		return 0;
	}

}
