package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;

/**
 * @author User
 *
 */
public class BacktrackingFlow extends PacketBase{
	public static int SIZE = 108;
	//tuple	StatisTuple10	56	10元组信息
	private long macSrc;          //源MAC  8 
	private long macDst;          //目的MAC 8
	private long ipSrc;              //源IP 8
	private long ipDst;              //目的IP 8
	private long portSrc;           //源端口，如果没有，为-1
	private long portDst;           //目标端口，如果没有，为-1
	private int l3Proto;           //第三层协议ID，如果没有，为-1
	private int l4Proto;          //第四层协议ID，如果没有，为-1
	private int tos;                 //Tos，如果没有，为-1
	private int vlanId;            //vlan ID，如果没有，为-1
	
	private long bytes;	//	8	字节总数
	private long packets;	//	8	数据包总数
	private long tcpSp;	//	8	tcp同步包数
	private long tcpScpn;//	8	tcp同步确认包数
	private long tcpSrp;	//	8	tcp同步重置包数
	private long appId;	//	4	appID
	private long appGroupId;//	4	app组ID
	private long mplsLabel;//	4	


	
	
	
	@Override
	public PacketBase  Parse(PacketHeader header,ByteBuffer data) throws Exception {
		BacktrackingFlow backFlow = new BacktrackingFlow();
		backFlow.macSrc = data.getLong(8);          //源MAC  8
		
		backFlow.macDst = data.getLong(8);          //目的MAC 8
		
		backFlow.ipSrc = data.getLong(8);              //源IP 8
		
		backFlow.ipDst = data.getLong(8);              //目的IP 8
		
		backFlow.portSrc = data.getInt(4);           //源端口，如果没有，为-1
		
		backFlow.portDst = data.getInt(4);           //目标端口，如果没有，为-1
		
		backFlow.l3Proto = data.getInt(4);           //第三层协议ID，如果没有，为-1
		
		backFlow.l4Proto = data.getInt(4);          //第四层协议ID，如果没有，为-1
		
		backFlow.tos = data.getInt(4);                 //Tos，如果没有，为-1
		
		backFlow.vlanId = data.getInt(4);            //vlan ID，如果没有，为-1
		
		
		backFlow.bytes = data.getLong(8);	//	8	字节总数
		
		backFlow.packets = data.getLong(8);	//	8	数据包总数
		
		backFlow.tcpSp = data.getLong(8);	//	8	tcp同步包数
		
		backFlow.tcpScpn = data.getLong(8);//	8	tcp同步确认包数
		
		backFlow.tcpSrp = data.getLong(8);	//	8	tcp同步重置包数
		
		backFlow.appId = data.getInt(4);	//	4	appID
		
		backFlow.appGroupId = data.getInt(4);//	4	app组ID
		
		backFlow.mplsLabel = data.getInt(4);//	4	
		
		
		return backFlow;
	}

	@Override
	public int getUnitPacketLength() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String[] getData() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getInterfaceNumber() {
		// TODO Auto-generated method stub
		return 0;
	}
	
}
