package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;
import java.util.concurrent.TimeUnit;


 
 

public class BussFlowMidd extends PacketBase {
	private  int UNIT_DATA_LENGTH =3569; 
	
	public String id; //id
	public long src_mac;
	public long dst_mac;
	public int msg_len;                 //消息长度
	public int msg_type;                //消息类型
	public int protocol;                //协议名
	public String session_serial_number;//会话序列号			
	public String  buss_type;//业务服务资源编码（C_01）
	public String  net_segment;//网段标识(客户-web)
	public long request_ip;//Web客户端IP
	public int request_port;//Web客户端端口
	public long  response_ip;//Web服务器IP
	public int response_port;//Web服务器端口
	public long start_tv_sec;//Web开始时间秒
	public long start_tv_usec;//开始时间毫秒
	public long end_tv_sec;//结束时间秒
	public long end_tv_usec;//结束时间微妙
	public String disc_resource_ident;    //web：url   mid:apiBody   db：sql
	public String name;               //web:操作系统   midd：interfaceName  db:db_name 
	//web midd
	public String session_id;//sessionid
	public int request_msg_length;  //请求报文长度
	public String request_msg_detail;   //请求报文详情
	public int response_msg_length; //响应报文长度
	public String response_msg_detail;  //响应报文详情
	//web段
	public String reter_url;           
	public String x_requested_with;
	public long req_method;         //请求方式
	public String content_type;     //请求类型
	public String accept;           //jieshou
	public int req_cookie_leng;//请求cookie报文长度
	public String req_cookie_detail;//请求cookie报文详情
	public long t_intodb_time;
	public int load_or_step;        //0: 页面   1：加载项   2：非web段数据 
	public String business_detail_mesg;
	public String bussiness_key_mesg;  //关键字  格式：key=val|key=val....
	public int isUncomplete;    //组包是否完全    0：组包完整  1：不完整
	public int deal_state=1;
	public int server_res_code;
	public long server_response_time;
	public long client_translate_time;
	public String browser;
	public int server_start_tv_sec;
	public long server_start_tv_usec;
	public int server_end_tv_sec;
	public long server_end_tv_usec;
	public String probe_ip;
	public int probe_if;
	public long server_translate_time;
	public long time_flag;	
	public String channel;
	public String base_code;
	public String ori_api;
	public String remain_data;
	public long bytes_in;
	public long bytes_out;
	public int package_in;
	public int package_out;
	public String  dataId;
	public int filterId;
	
	@Override
	public int getUnitPacketLength() {
		// TODO Auto-generated method stub
		return UNIT_DATA_LENGTH;
	}

	public BussFlowMidd  Parse(PacketHeader header,ByteBuffer data)
			throws Exception {
		BussFlowMidd buss = new BussFlowMidd();		
//		buss.m_Header = header;
		
 		buss.msg_type = header.getTableID();
 
		buss.src_mac = data.getLong(8);
	 
		buss.dst_mac = data.getLong(8);
		var macFilterFlag = false ;
		if(macFilterFlag && buss.src_mac!=0 && buss.dst_mac==0){
			return null;
		}

 

		data.position( data.position() + 28);

		buss.protocol= data.getInt( 4);
		 
		buss.bytes_out = data.getLong(4);
		 
		buss.bytes_in = data.getLong(4);
		 
		buss.package_out =  data.getInt( 4);
		 
		buss.package_in =  data.getInt( 4);
		 
		
		buss.session_serial_number = data.alignedSlice( 24).toString();
 
		data.position( data.position() + 4);
//		buss.req_method = data.getLong(4);
//		 
//		buss.content_type = data.alignedSlice( 40).toString();
//		offset += 40;
//		buss.accept = data.alignedSlice( 40).toString();
//		offset += 40;
		buss.probe_if= data.getInt(4);
		 
//		buss.buss_type =data.alignedSlice(10).toString();
//		offset += 10;
		buss.channel=data.alignedSlice(24).toString();
	 
//		buss.session_id=data.alignedSlice(36).toString();
//		offset += 36;
//		buss.net_segment=data.alignedSlice(6).toString();
//		offset += 6;
		buss.request_ip=data.getLong();
		 
		buss.request_port= data.getInt(4);
	 
		buss.response_ip=data.getLong();
	 
		buss.response_port= data.getInt(4);
	 
		//开始时间
		buss.start_tv_sec=data.getLong();
	 
		buss.start_tv_usec=data.getLong();
	 
		//结束时间
		buss.end_tv_sec=data.getLong();
	 
		buss.end_tv_usec=data.getLong();
	 
//		buss.deal_state= data.getInt(4);
	 
		buss.server_res_code =  data.getInt( 2);
	 
		buss.server_translate_time=data.getLong();
		 
		
		buss.server_start_tv_sec= data.getInt(4);
		 
		buss.server_start_tv_usec=data.getLong();
		 
		//结束时间
		buss.server_end_tv_sec= data.getInt(4);
		 
		buss.server_end_tv_usec=data.getLong();
		 
		
		buss.server_response_time=data.getLong();
		 
		buss.client_translate_time=data.getLong();
		 
		buss.isUncomplete =  data.getInt( 4);
		 
		buss.time_flag= data.getInt( 4);
 
		int detailMsgLen =  data.getInt( 4);
		 
		int keyMsgLen =  data.getInt( 4);
		 
		int apiLen =  data.getInt( 4);
		 
		buss.request_msg_length =  data.getInt( 4);
		 
		buss.response_msg_length =  data.getInt( 4);
		 
		int remainLen =  data.getInt( 4);
		 
		
		buss.business_detail_mesg=data.alignedSlice(detailMsgLen).toString();
		 
		buss.bussiness_key_mesg = data.alignedSlice( keyMsgLen).toString();
		 
		buss.ori_api=data.alignedSlice( apiLen).toString();
	 
		buss.request_msg_detail = utils.ByteBufferUTF8String(data, buss.request_msg_length);
 
		buss.response_msg_detail = utils.ByteBufferUTF8String(data, buss.response_msg_length);
		data.position(data.position()+remainLen);

		
		
		/*if(SystemConfigManager.projectName.contains("GDYDBPM")){
			boolean exist=false;
			if(SystemConfigManager.reduceFlag){
				
				redisTemplate = (RedisTemplate<String, String>) ApplicationContextUtil.getBean("redisTemplate");
				exist = reduceByKey(buss);
			}
			
			//不存在就加入缓存
			if(!exist)return buss;
			//存在就返回空
			return null;
		}*/
		
		return buss;
	}

	public String getBussType() {
		return buss_type;
	}

	@Override
	public String[] getData() {
		String data[] = new String[35];//贵阳
		
		return data;
	}

	@Override
	public int getInterfaceNumber() {
		
		return 0;
	}
	
	/**
	 * 如果已经存在这个session_id（即key），则说明是重复数据，不再进行后续操作
	 * @param buss
	 * @return
	 */
	/*private boolean reduceByKey(BussFlowMidd buss) {
		String coding = CodingGeneration.md5GenCoding2(buss.ori_api);
		String key=buss.session_serial_number+"|"+buss.request_ip+"|"+buss.request_port+"|"+buss.response_ip+"|"+buss.response_port+"|"+coding+"|"+buss.business_detail_mesg;
		
		//分布式同步锁，如果存在该key或者锁已经被获取则返回false，设置
		if(redisTemplate.opsForValue().setIfAbsent(key, System.currentTimeMillis()+"")){
			redisTemplate.expire(key,SystemConfigManager.keyExistTime,TimeUnit.SECONDS);
			return false;
		}
		
		return true;
	}*/
}
