package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;

public class BussFlowOrl extends PacketBase {

    public int msg_type;
    public int msg_version;
    public int msg_seq;
    public int msg_len;
    public long request_mac;
    public long response_mac;
    public long request_ip;
    public int request_port;
    public long response_ip;
    public int response_port;
    public int probeif;
    public int protocol;
    public long start_tv_sec;//Web开始时间秒
    public long start_tv_usec;//开始时间毫秒
    public long end_tv_sec;//结束时间秒
    public long end_tv_usec;//结束时间微妙
    public int req_len;
    public int res_len;
    public int busi_msg_len;
    public int key_msg_len;
    public int detail_msg_len;
    public int remain_len;
    public String business_code;
    public String sessionid;
    public String req_data;
    public String res_data;
    public String busi_msg;
    public String busi_key_msg;
    public String busi_detail_msg;
    public String remain_data;

    @Override
    public PacketBase  Parse(PacketHeader header,ByteBuffer data) throws Exception {
        BussFlowOrl orl = new BussFlowOrl();
        orl.msg_type = header.getNowType();
        orl.request_mac =data.getLong(8);
         
        orl.response_mac =data.getLong(8);
         
        orl.request_ip =data.getLong(4);
         
        orl.request_port = data.getInt(4);
         
        orl.response_ip =data.getLong(4);
         
        orl.response_port = data.getInt(4);
         
        orl.probeif = data.getInt(4);
         
        orl.protocol = data.getInt(4);
         
        orl.start_tv_sec =data.getLong(4);
         
        orl.start_tv_usec =data.getLong(4);
         
        orl.end_tv_sec =data.getLong(4);
         
        orl.end_tv_usec =data.getLong(4);
         
        int req_len = data.getInt(4);
         
        int res_len = data.getInt(4);
         
        int busi_msg_len = data.getInt(4);
         
        int key_msg_len = data.getInt(4);
         
        int detail_msg_len = data.getInt(4);
         
        int remain_len = data.getInt(4);
         
        orl.business_code = data.alignedSlice( 32).toString();
         
        orl.sessionid = data.alignedSlice( 80).toString();
         
        orl.req_data = data.alignedSlice( req_len).toString();
         
        orl.res_data = data.alignedSlice( res_len).toString();
         
        orl.busi_msg = data.alignedSlice( busi_msg_len).toString();
         
        orl.busi_key_msg = data.alignedSlice( key_msg_len).toString();
         
        orl.busi_detail_msg = data.alignedSlice( detail_msg_len).toString();
         
        orl.remain_data = data.alignedSlice( remain_len).toString();
         
        return orl;
    }

    @Override
    public int getUnitPacketLength() {
        return 0;
    }

    @Override
    public String[] getData() {
        return new String[0];
    }

    @Override
    public int getInterfaceNumber() {
        return 0;
    }
}
