package com.yuandian.dataflow.proto.decode;



import java.io.Serializable;
import java.nio.ByteBuffer;
import java.util.Date;

import io.netty.buffer.ByteBuf;

 

/**
 * 移植zjm流量信息接收类
 * Leehr
 *
 */
public class DataBaseModel extends PacketBase implements Serializable{

	
	private static final long serialVersionUID = 1L;

	private static final String split=";";
	
	private long mac_src;  //源MAC
	private long mac_dst;  //目标MAC
	private long ip_src;   //源IP
	private long ip_dst;   //目标IP
	private long port_src; //源端口，如果没有，为-1
	private long port_dst; //目标端口，如果没有，为-1
	private long l3_proto; //第三层协议ID，如果没有，为-1
	private long l4_proto; //第四层协议ID，如果没有，为-1
	private long tos;      //Tos，一个字节，如果没有，为-1
	private long vlan_id;  //vlan ID，如果没有，为-1 
	
	private long bytes;    //字节总数
	private long packets;  //数据包总数
	 
	private long packets_syn;  //TCP同步包数
	private long packets_syn_ack; //TCP同步确认包数
	private long packets_syn_rst; //TCP同步重置包数

	private long timestamp; //时间戳,秒

	private long appid;//应用ID
	private long app_group_id;
	private long mpls_label;
	
	private long pkts_syn_rx; //tcp同步包，接收
	private long pkts_syn_ack_rx;//tcp同步确认包，接收
	private long pkts_syn_rst_rx; //tcp同步重置包，接收
	private long pkts_fin;//tcp终止包，接收
	private long pkts_rst;//tcp重置包，接收

	private long bytes_rx;//字节收
	private long packets_rx;//数据包收
	
	private long probe_time_sec;
	private Date probe_time;
	private Date createTime;
	
	public String getKey(){
		StringBuffer strb=new StringBuffer();
		strb.append(timestamp).append(split);
		strb.append(mac_src).append(split);
		strb.append(mac_dst).append(split);
		strb.append(ip_src).append(split);
		strb.append(ip_dst).append(split);
		strb.append(port_src).append(split);
		strb.append(port_dst).append(split);
		strb.append(l3_proto).append(split);
		strb.append(l4_proto).append(split);
		strb.append(tos).append(split);
		strb.append(vlan_id).append(split);
		strb.append(appid);
		return strb.toString();
	}
	
	public DataBaseModel Parse(ByteBuffer data)throws Exception {

		if (data.position() + 108 > data.array().length)
			throw new Exception("data length error!");
	
		DataBaseModel db = new DataBaseModel();
		db.mac_src = data.getLong( 8);
	 
		db.mac_dst = data.getLong( 8);
 
		db.ip_src = data.getLong( 8);
 
		db.ip_dst = data.getLong( 8);
	 
		db.port_src = data.getInt(4);
 
		db.port_dst = data.getInt(4);
 
		db.l3_proto = data.getInt(4);
 
		db.l4_proto = data.getInt(4);
 
		db.tos = data.getInt(4);
 
		db.vlan_id = data.getInt(4);
 
		db.bytes = data.getLong( 8);
	 
		db.packets = data.getLong( 8);
	 
		db.packets_syn = data.getLong( 8);
		
	 
		db.packets_syn_ack = data.getLong( 8);
 
		db.packets_syn_rst = data.getLong( 8);
 
		/**
		 * 2015-12-10txy 新增3个解析
		 */
		db.appid=data.getLong( 4);
 
		db.app_group_id=data.getLong( 4);
 
		db.mpls_label=data.getLong( 4);
 
		return db;
	}
	
	public String toString(){
			StringBuffer strb = new StringBuffer();
			strb.append(timestamp).append(",");
			strb.append(mac_src).append(",");
			strb.append(mac_dst).append(",");
			strb.append(ip_src).append(",");
			strb.append(ip_dst).append(",");
			strb.append(port_src).append(",");
			strb.append(port_dst).append(",");
			strb.append(l3_proto).append(",");
			strb.append(l4_proto).append(",");
			strb.append(tos).append(",");
			strb.append(vlan_id).append(",");
			strb.append(appid).append(",");
			strb.append(packets_syn).append(",");
			strb.append(pkts_syn_rx).append(",");
			strb.append(packets_syn_ack).append(",");
			strb.append(pkts_syn_ack_rx).append(",");
			strb.append(packets_syn_rst).append(",");
			strb.append(pkts_syn_rst_rx).append(",");
			strb.append(pkts_fin).append(",");
			strb.append(pkts_rst).append(",");
			strb.append(bytes).append(",");
			strb.append(packets).append(",");
			strb.append(bytes_rx).append(",");
			strb.append(packets_rx).append(",");
			strb.append(app_group_id).append(",");
			strb.append(mpls_label).append("\n");
			return strb.toString();
	}
	
	
	public long getProbeTimeSec() {
		return probe_time_sec;
	}

	public void setProbe_time_sec(long probe_time_sec) {
		this.probe_time_sec = probe_time_sec;
	}

	public Date getProbe_time() {
		return probe_time;
	}

	public void setProbe_time(Date probe_time) {
		this.probe_time = probe_time;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public long getTimestamp() {
		return timestamp;
	}
	public void setTimestamp(long timestamp) {
		this.timestamp = timestamp;
	}
	public long getMac_src() {
		return mac_src;
	}
	public void setMac_src(long macSrc) {
		mac_src = macSrc;
	}
	public long getMac_dst() {
		return mac_dst;
	}
	public void setMac_dst(long macDst) {
		mac_dst = macDst;
	}
	public long getIp_src() {
		return ip_src;
	}
	public void setIp_src(long ipSrc) {
		ip_src = ipSrc;
	}
	public long getIp_dst() {
		return ip_dst;
	}
	public void setIp_dst(long ipDst) {
		ip_dst = ipDst;
	}
	public long getPort_src() {
		return port_src;
	}
	public void setPort_src(long portSrc) {
		port_src = portSrc;
	}
	public long getPort_dst() {
		return port_dst;
	}
	public void setPort_dst(long portDst) {
		port_dst = portDst;
	}
	public long getL3_proto() {
		return l3_proto;
	}
	public void setL3_proto(long l3Proto) {
		l3_proto = l3Proto;
	}
	public long getL4_proto() {
		return l4_proto;
	}
	public void setL4_proto(long l4Proto) {
		l4_proto = l4Proto;
	}
	public long getTos() {
		return tos;
	}
	public void setTos(long tos) {
		this.tos = tos;
	}
	public long getVlan_id() {
		return vlan_id;
	}
	public void setVlan_id(long vlanId) {
		vlan_id = vlanId;
	}
	public long getAppid() {
		return appid;
	}
	public void setAppid(long appid) {
		this.appid = appid;
	}

	public long getPkts_syn_rx() {
		return pkts_syn_rx;
	}
	public void setPkts_syn_rx(long pktsSynRx) {
		pkts_syn_rx = pktsSynRx;
	}

	public long getPkts_syn_ack_rx() {
		return pkts_syn_ack_rx;
	}
	public void setPkts_syn_ack_rx(long pktsSynAckRx) {
		pkts_syn_ack_rx = pktsSynAckRx;
	}

	public long getPkts_syn_rst_rx() {
		return pkts_syn_rst_rx;
	}
	public void setPkts_syn_rst_rx(long pktsSynRstRx) {
		pkts_syn_rst_rx = pktsSynRstRx;
	}
	public long getPkts_fin() {
		return pkts_fin;
	}
	public void setPkts_fin(long pktsFin) {
		pkts_fin = pktsFin;
	}
	public long getPkts_rst() {
		return pkts_rst;
	}
	public void setPkts_rst(long pktsRst) {
		pkts_rst = pktsRst;
	}
	public long getBytes() {
		return bytes;
	}
	public void setBytes(long bytes) {
		this.bytes = bytes;
	}
	public long getPackets() {
		return packets;
	}
	public void setPackets(long packets) {
		this.packets = packets;
	}
	public long getBytes_rx() {
		return bytes_rx;
	}
	public void setBytes_rx(long bytesRx) {
		bytes_rx = bytesRx;
	}
	public long getPackets_rx() {
		return packets_rx;
	}
	public void setPackets_rx(long packetsRx) {
		packets_rx = packetsRx;
	}

	public long getPackets_syn() {
		return packets_syn;
	}

	public void setPackets_syn(long packetsSyn) {
		packets_syn = packetsSyn;
	}

	public long getPackets_syn_ack() {
		return packets_syn_ack;
	}

	public void setPackets_syn_ack(long packetsSynAck) {
		packets_syn_ack = packetsSynAck;
	}

	public long getPackets_syn_rst() {
		return packets_syn_rst;
	}

	public void setPackets_syn_rst(long packetsSynRst) {
		packets_syn_rst = packetsSynRst;
	}

	public long getApp_group_id() {
		return app_group_id;
	}

	public void setApp_group_id(long app_group_id) {
		this.app_group_id = app_group_id;
	}

	public long getMpls_label() {
		return mpls_label;
	}

	public void setMpls_label(long mpls_label) {
		this.mpls_label = mpls_label;
	}

	public static String getSplit() {
		return split;
	}

	@Override
	public PacketBase  Parse(PacketHeader header,ByteBuffer data)
			throws Exception {
		return null;
	}

	@Override
	public int getUnitPacketLength() {
		return 0;
	}

	@Override
	public String[] getData() {
		return null;
	}

	@Override
	public int getInterfaceNumber() {
		return 0;
	}
	
	
	
}
