package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;

public class DataFlow  extends PacketBase {
	private final int UNIT_DATA_LENGTH = 157;//贵阳 
	public String id;
	
	public Integer msg_type;                //消息类型
	public Integer msg_version;             //消息版本
	public Integer msg_seq;                 //序列号
	public Integer msg_len;                 //消息长度
	public Integer probe_if;                //接口号
	public Long timestamp;    //时间戳
	public Long mac_src;      //源物理地址
	public Long mac_dst;      //目的物理地址
	public Integer vlan_id;                 //vlan_id
	public Long l3_proto;     //l3层协议
	public Long l4_proto;     //l4层协议
	public Integer tos;                     //tos
	public Integer retran_count;            //重传次数
	public Integer reset_count;             //重置次数
	public Integer zerowin_count;           //零窗口次数
	public Integer protocol;                //协议名
	public Long seq;
	public Long ack;
	public Integer recog_status;            //识别类型标识
	public Long bytes;        //总字节
	public Long packets;      //总包数
	public  Integer start_tv_sec;//Web开始时间秒
	public Long start_tv_usec;//开始时间毫秒
	public Integer end_tv_sec;//结束时间秒
	public  Long end_tv_usec;//结束时间微妙
	public  Integer server_start_tv_sec;//服务器响应开始时间秒
	public Long server_start_tv_usec;//服务器响应开始时间毫秒
	public Integer server_end_tv_sec;//服务器响应结束时间秒
	public  Long server_end_tv_usec;//服务器响应结束时间微妙
	
	public Long server_response_time;//Web服务器响应时间
	public Long client_translate_time;//Web客户端传输耗时
	public Long server_translate_time;//Web服务器传输耗时

	public Long bytes_in;
	public Long bytes_out;
	public Long packets_in;
	public Long packets_out;
	public Long ip_src;       //源IP
	public Long ip_dst;       //目的IP
	public Long port_src;     //源端口
	public Long port_dst;     //目的端口
	public Long probeIP;              //探针IP
	
	public Long intodb_time;
	public Long count = 1L;


	
	@Override
	public PacketBase  Parse(PacketHeader header,ByteBuffer data) throws Exception {
		if (data.position() + UNIT_DATA_LENGTH > data.array().length)
			throw new Exception("data length error!");
		DataFlow dflow = new DataFlow();		
//		dflow.m_Header = header;
		
		dflow.msg_type = header.getTableID();
 
		dflow.ip_src = data.getLong(4);
		 
		dflow.ip_dst = data.getLong(4);
		 
 

		data.position(data.position()+4);

		dflow.probe_if =  data.getInt(4);
		 
 
 
 
 

		data.position(data.position() + 32 + 12 + 12 + 8 );

		dflow.bytes_in = data.getLong(4);
		 
		dflow.bytes_out = data.getLong(4);
		 
		dflow.packets_in = data.getLong(4);
		 
		dflow.packets_out = data.getLong(4);
		 
		dflow.bytes = data.getLong(4);
		 
		dflow.packets = data.getLong(4);
	 
		data.position(data.position() + 12 + 12 + 16 + 16 );
		return dflow;
	}
	@Override
	public int getUnitPacketLength() {
		return UNIT_DATA_LENGTH;
	}
	@Override
	public String[] getData() {
		String data[] = new String[45];
		return data;
	}
	@Override
	public int getInterfaceNumber() {
		return Integer.parseInt(probe_if.toString());
	}
}
